"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withUnit = exports.getUnitFromChannel = void 0;

var _react = _interopRequireDefault(require("react"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _reactRedux = require("react-redux");

var _units = require("../units.mjs");

var _beClient = require("../be-client");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * units record data model.
 * {
 *   id: 'units',        // Config id, if config exists in DB. (always 'units')
 *   isMetric: Boolean,  // True: User have choosen to use metrics as standard.
 *   kinds: {},          // Key/Values: Kinds as keys; Unit as value.
 *   rid: '',            // Config record id, if config exists in DB.
 *   systems: {          // Contains default values for metric & impreial conversions!
 *     'kind': [{metric}, {impreial}],
 *    },
 * }
 */
var hoc = (0, _reactRedux.connect)(function (state) {
  return {
    unitSettings: state.profile.unitSettings
  };
});
/**
 * DEPRECATED! DO NOT USE!
 */
// export const withUnits = () => {
//   return Component => {
//     return hoc(props => {
//       console.warn('withUnits is deprecated and will be removed!');
//       return <Component {...props} />;
//     });
//   };
// };
// const getUnitsFromProfile = profile => {
//   const { configurations: { units = { isMetric: true } } = {} } = profile || {};
//   return units;
// };

var getUnitFromChannel =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(channelRid) {
    var channelAndType, type, unit;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _beClient.getChannelAndTypeFromRid)(channelRid);

          case 2:
            channelAndType = _context.sent;

            if (channelAndType) {
              _context.next = 5;
              break;
            }

            return _context.abrupt("return", {});

          case 5:
            // const { channel, type } = channelAndType;
            type = channelAndType.type;

            if (type) {
              _context.next = 8;
              break;
            }

            return _context.abrupt("return", {});

          case 8:
            unit = type.unit; // return { kind, unit, channel };

            return _context.abrupt("return", unit);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getUnitFromChannel(_x) {
    return _ref.apply(this, arguments);
  };
}(); // const transformValues = (values, unitObj, unitSettings) => {
//   if (values === undefined) return { values, unit: undefined };
//   let result;
//   if (unitObj.unit) result = representUnit(values, unitObj.unit, unitSettings);
//   else if (unitObj.kind) result = representFromBaseUnit(values, unitObj.kind, unitSettings);
//   return result;
// };
// export const transformSet = (data, unit, units) => {
//   if (units === undefined) throw new Error('transformSet: units is undefiend!');
//
//   if (unit.unit) {
//     data.datasets.forEach(set => {
//       // eslint-disable-next-line no-param-reassign
//       set.data = representUnit(set.data, unit.unit, units).value;
//     });
//   } else if (unit.kind) {
//     data.datasets.forEach(set => {
//       // eslint-disable-next-line no-param-reassign
//       set.data = representFromBaseUnit(set.data, unit.kind, units).value;
//     });
//   }
// };

/**
 * Transforms channel data with unit information in channelType.
 * @param {Object} settings Settings from widget config.
 * @param {String} settings.dataKey The property key to transform values on.
 * @param {Object} settings.unitKey The property key to pass the unit name on.
 * @param {Array<string>} settings.paths The property paths to transform.
 * @param {Boolean} settings.isMsg If true the value is a raw TiipMessage.
 */


exports.getUnitFromChannel = getUnitFromChannel;

var withUnit = function withUnit(_ref2) {
  var dataKey = _ref2.dataKey,
      _ref2$unitKey = _ref2.unitKey,
      unitKey = _ref2$unitKey === void 0 ? 'unit' : _ref2$unitKey,
      paths = _ref2.paths,
      _ref2$isMsg = _ref2.isMsg,
      isMsg = _ref2$isMsg === void 0 ? false : _ref2$isMsg,
      channelRid = _ref2.channelRid;
  return function (Component) {
    return hoc(function (_ref3) {
      var _ref4;

      var value = _ref3[dataKey],
          _ref3$unitSettings = _ref3.unitSettings,
          unitSettings = _ref3$unitSettings === void 0 ? {} : _ref3$unitSettings,
          rest = _objectWithoutProperties(_ref3, [dataKey, "unitSettings"].map(_toPropertyKey));

      var _useState = (0, _react.useState)(true),
          _useState2 = _slicedToArray(_useState, 2),
          loading = _useState2[0],
          setLoading = _useState2[1];

      var _useState3 = (0, _react.useState)(),
          _useState4 = _slicedToArray(_useState3, 2),
          unit = _useState4[0],
          setUnit = _useState4[1];

      var _useState5 = (0, _react.useState)(),
          _useState6 = _slicedToArray(_useState5, 2),
          targetUnit = _useState6[0],
          setTargetUnit = _useState6[1];

      var _useRef = (0, _react.useRef)(),
          _useRef2 = _slicedToArray(_useRef, 1),
          converter = _useRef2[0];

      var kind = (0, _react.useMemo)(function () {
        return (0, _units.unitToKind)(unit);
      }, [unit]);
      (0, _react.useEffect)(function () {
        // Load channel type info to get unit of the data
        getUnitFromChannel(channelRid).then(function (result) {
          setUnit(result);
          setLoading(false);
        });
      }, [setUnit, setLoading]);
      (0, _react.useEffect)(function () {
        // On unit settings changes -> update target unit
        if (!kind) return;
        var toUnit = unitSettings[kind];
        if (toUnit) setTargetUnit(toUnit);
      }, [unitSettings, setTargetUnit]);
      (0, _react.useEffect)(function () {
        // If unit or target unit changes -> create a new converter
        if (!unit || !targetUnit || Object.is(unit, targetUnit)) return;

        var _getConverter = (0, _units.getConverter)(unit, targetUnit),
            _getConverter2 = _slicedToArray(_getConverter, 2),
            resultingUnit = _getConverter2[0],
            conv = _getConverter2[1];

        if (!resultingUnit) return;
        setTargetUnit(resultingUnit);
        converter.current = conv;
      }, [unit, targetUnit, setTargetUnit]);
      var newValue = (0, _react.useMemo)(function () {
        // if target unit or value changes -> convert data
        if (!converter.current) return value;

        if (isMsg) {
          if (Array.isArray(value)) {
            return value.map(function (msg) {
              return _objectSpread({}, msg, {
                pl: converter.current(msg.pl || [])
              });
            });
          }

          return _objectSpread({}, value, {
            pl: converter.current(value.pl || [])
          });
        }

        return converter.current(newValue);
      }, [targetUnit, value]); // if (unit && values) {
      //   let targetUnit;
      //
      //   if (isMsg) {
      //     // Tiip|Array<Tiip>
      //     const newValues = (Array.isArray(values) ? values : [values]).map(value => {
      //       const transformed = transformValues(value.pl, unit, unitSettings);
      //       targetUnit = transformed.unit;
      //       return R.assoc('pl', transformed.values, value);
      //     });
      //     newProps[valueKey] = newValues;
      //   } else {
      //     // Number|Array<Number>
      //     const transformed = transformValues(values, unit, unitSettings);
      //     targetUnit = transformed.unit;
      //     newProps[valueKey] = transformed.values;
      //   }
      //
      //   if (targetUnit) {
      //     if (unitKey) newProps[unitKey] = ' '.concat(getUnitLabel(targetUnit, unitSettings));
      //
      //     if (paths) {
      //       paths.forEach(path => {
      //         const pathValue = getPath(path, props);
      //         if (pathValue !== undefined)
      //           newProps = setPath(
      //             path,
      //             transformValues(pathValue, unit, unitSettings).values,
      //             newProps,
      //           );
      //       });
      //     }
      //   }
      // }

      return loading ? _react["default"].createElement(_CircularProgress["default"], null) : _react["default"].createElement(Component, _extends({}, rest, (_ref4 = {}, _defineProperty(_ref4, dataKey, newValue), _defineProperty(_ref4, unitKey, targetUnit), _ref4), {
        key: targetUnit
      }));
    });
  };
};

exports.withUnit = withUnit;